<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- 
IGAC proyecto SNC
@author 			christian.rodriguez
@modified 			felipe.cadena
@cu 				CU-SA-AC-090 Reasignar interventor contrato

@ManagedBean 
-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                template="../../templates/generalCU.xhtml"
                xmlns:fn="http://java.sun.com/jsp/jstl/functions"
                xmlns:misc="http://java.sun.com/jsf/composite/misc">

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .::Reasignar interventor contrato::.
    </ui:define>

    <ui:define name="content">

        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" onerror="statusDialog.hide();" />
        <p:focus />


        <p:spacer height="5" width="0" />

        <h:form id="consultarInterventoresContratosForm">

            <p:messages id="msgsAdministrarAdicionesContrato" showDetail="false"
                        globalOnly="false" />

            <h:panelGrid id="busquedaInterventoresContratosPG" width="100%">

                <p:fieldset>

                    <legend>
                        <h:outputText value="Criterios de búsqueda"
                                      styleClass="legendTitle" />
                    </legend>


                    <h:panelGrid columns="2" cellspacing="7"
                                 columnClasses="colMediana, colGrande">

                        <h:panelGroup>
                            <h:outputLabel value="Tipo busqueda:"
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="* " styleClass="requiredLabelStyle" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:selectOneRadio id="tipoBusqueda"
                                              value="#{reasignarInterventorContrato.banderaBusquedaPorNumeroContrato}"
                                              required="true">
                                <f:selectItem itemLabel="Por número de contrato"
                                              itemValue="true" />
                                <f:selectItem itemLabel="Por interventor" itemValue="false"/>
                                <p:ajax
                                    update=":consultarInterventoresContratosForm:busquedaInterventoresContratosPG"
                                    listener="#{reasignarInterventorContrato.limpiarCamposBusqueda}"
                                    process="@this" />
                            </h:selectOneRadio>
                            <p:message for="tipoBusqueda" display="icon" />
                        </h:panelGrid>

                    </h:panelGrid>

                    <h:panelGrid columns="4" cellspacing="7"
                                 columnClasses="colMediana, colGrande, colMediana, colGrande"
                                 rendered="#{reasignarInterventorContrato.banderaBusquedaPorNumeroContrato}">

                        <h:panelGroup>
                            <h:outputLabel value="Número de contrato:"
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="* " styleClass="requiredLabelStyle" />
                        </h:panelGroup>

                        <h:inputText required="true" requiredMessage="Debe ingresar el número de contrato"
                                     value="#{reasignarInterventorContrato.filtro.numeroContrato}" />


                        <h:outputLabel value="Vigencia:" styleClass="outputLabelStyle" />
                        <h:selectOneMenu label="Vigencia"
                                         value="#{reasignarInterventorContrato.filtro.vigencia}">
                            <f:selectItems value="#{general.rangoAniosAscDesdeActual}" />
                        </h:selectOneMenu>
                    </h:panelGrid>

                    <h:panelGrid columns="4" cellspacing="7"
                                 columnClasses="colMediana, colGrande, colMediana, colGrande"
                                 rendered="#{!reasignarInterventorContrato.banderaBusquedaPorNumeroContrato}">

                        <h:outputLabel value="Nombre interventor:"
                                       styleClass="outputLabelStyle" />
                        <h:selectOneMenu label="Nombre interventor"
                                         value="#{reasignarInterventorContrato.filtro.idInterventor}">
                            <f:selectItems value="#{reasignarInterventorContrato.interventoresMenu}" />
                        </h:selectOneMenu>

                        <h:panelGroup>
                            <h:outputLabel value="Número documento interventor:"
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="* " styleClass="requiredLabelStyle" />
                        </h:panelGroup>
                        <h:inputText required="true" requiredMessage="Debe ingresar el número de documento del interventor"
                                     value="#{reasignarInterventorContrato.filtro.numeroDocumentoInterventor}" />

                    </h:panelGrid>

                    <h:panelGrid columns="1" cellspacing="7">

                        <p:commandButton value="Buscar" icon="ui-icon ui-icon-search"
                                         action="#{reasignarInterventorContrato.buscar}"
                                         update=":consultarInterventoresContratosForm"
                                         onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();" />

                    </h:panelGrid>
                </p:fieldset>

            </h:panelGrid>

            <p:fieldset>
                <legend>
                    <h:outputText value="Resultados de la consulta"
                                  styleClass="legendTitle" />
                </legend>

                <h:panelGrid columns="1" cellspacing="7" width="100%">

                    <p:dataTable id="contratosAsciadosDT"
                                 value="#{reasignarInterventorContrato.contratosEncontrados}"
                                 selection="#{reasignarInterventorContrato.contratoSeleccionado}"
                                 var="contrato" rowKey="#{contrato.id}" paginator="true" rows="10"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport}
                                 {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="10,20,30" paginatorPosition="bottom"
                                 emptyMessage="No se encontraron contratos para los criterios de busqueda especificados">

                        <f:facet name="header">
                            Contratos interadministrativos asociados
                        </f:facet>

                        <p:column selectionMode="multiple" style="width:18px" />  

                        <p:column headerText="Número contrato">
                            <h:outputText value="#{contrato.numero} - #{contrato.vigencia}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Tipo documento">
                            <h:outputText id="PersonaTipoIdentificacionCV"
                                          value="#{contrato.entidadSolicitante.tipoIdentificacion}"
                                          styleClass="outputTextStyle">
                                <f:converter for="PersonaTipoIdentificacionCV"
                                             converterId="converterCB" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Número documento">
                            <h:outputText
                                value="#{contrato.entidadSolicitante.numeroIdentificacion}"
                                styleClass="outputTextStyle" />
                            <h:outputText
                                value=" - #{contrato.entidadSolicitante.digitoVerificacion}"
                                styleClass="outputTextStyle"
                                rendered="#{not empty contrato.entidadSolicitante.digitoVerificacion}" />
                        </p:column>

                        <p:column headerText="Persona natural/Razón social">
                            <h:outputText
                                value="#{contrato.entidadSolicitante.nombreCompleto}"
                                styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Valor total contrato">
                            <h:outputText value="#{contrato.valor}"
                                          styleClass="outputTextStyle">
                                <f:converter converterId="converterMoneda" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Número avalúos contratados">
                            <h:outputText value="#{contrato.numeroAvaluosContratados}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                    </p:dataTable>

                </h:panelGrid>

            </p:fieldset>
            <p:spacer height="10" />
            <p:fieldset>

                <legend>
                    <h:outputText value="Listado de posibles interventores"
                                  styleClass="legendTitle" />
                </legend>

                <h:panelGrid columns="1" cellspacing="7" width="100%">

                    <p:dataTable id="posiblesInterventoresDT"
                                 value="#{reasignarInterventorContrato.interventores}"
                                 selection="#{reasignarInterventorContrato.interventorSeleccionado}"
                                 var="interventor" rowKey="#{interventor.id}" paginator="true"
                                 rows="10"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport}
                                 {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="10,20,30" paginatorPosition="bottom"
                                 emptyMessage="No se encontraron interventores disponibles para asociar a contratos interadministrativos">

                        <f:facet name="header">
                            Listado de posibles interventores
                        </f:facet>

                        <p:column selectionMode="single" style="width:18px" />

                        <p:column headerText="Número documento">
                            <h:outputText
                                value="#{interventor.numeroIdentificacion}"
                                styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Nombre profesional">
                            <h:outputText
                                value="#{interventor.nombreCompleto}"
                                styleClass="outputTextStyle" />
                        </p:column>

                        <p:column
                            headerText="No. interventorias contratos prestación de servicios">
                            <h:outputText
                                value="#{fn:length(interventor.profesionalAvaluosContratos)}"
                                styleClass="outputTextStyle" />
                        </p:column>

                        <p:column
                            headerText="No. interventorias contratos interadministrativos">

                            <p:commandLink rendered="#{(fn:length(interventor.contratoInteradministrativos))>0}"
                                           value="#{fn:length(interventor.contratoInteradministrativos)}" immediate="true"
                                           oncomplete="interventoriasWV.show();"
                                           update=":interventoriasForm"
                                           styleClass="commandLinkStyle">
                                <f:setPropertyActionListener 
                                    target="#{reasignarInterventorContrato.interventorSeleccionado}"
                                    value="#{interventor}"/>
                            </p:commandLink>
                            <h:outputText rendered="#{!((fn:length(interventor.contratoInteradministrativos))>0)}"
                                          value="0"
                                          styleClass="outputTextStyle" />
                        </p:column>

                    </p:dataTable>

                    <p:commandButton value="Asignar interventor" icon="ui-icon-person"
                                     update=":consultarInterventoresContratosForm"
                                     onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();confirmacionAsignacionWV.show()" />
                </h:panelGrid>

            </p:fieldset>

            <p:separator style="width:925px;height:3px" />
            <p:spacer height="7" width="0" />
            <p:outputPanel layout="block" style="text-align:right">
                <p:commandButton value="Cerrar"
                                 action="#{reasignarInterventorContrato.cerrar}"
                                 icon="ui-icon-circle-close" immediate="true" ajax="false" />
                <p:spacer height="0" width="30" />
            </p:outputPanel>
            <p:spacer height="20" width="0" />
        </h:form>

        <!-- ...................... dialogs  ................................... -->

        <p:dialog dynamic="true" appendToBody="true" 
                  height="400" width="900"
                  header="Interventorias contratos interadministrativos"
                  widgetVar="interventoriasWV">
            <ui:include src="/avaluos/administracion/interventoriasContratoInteradministrativo.xhtml" />
        </p:dialog>

        <misc:ultimateConfirmDialogCC
            confirmMessage="¿Está seguro de reasignar el actual interventor de contrato(s)? "
            confirmUpdateOnYes=":consultarInterventoresContratosForm"
            confirmDialogWV="confirmacionAsignacionWV"
            voidActionOnYes="#{reasignarInterventorContrato.asignarInterventor}"
            yesLabel="Aceptar" noLabel="Cancelar" />
    </ui:define>
</ui:composition>